accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from django.utils.translation import gettext_lazy as _

from . import views


urlpatterns = [
    path(_('login/'), views.CustomLoginView.as_view(),
         name='custom-login'),
    # after logout, we need to go back to the login page
    path(_('logout/'), auth_views.logout_then_login,
         name='logout'),
    path(_('<int:pk>/update-account/'),
         views.UserUpdate.as_view(),
         name='user-update'),
    path(_('<int:pk>/password_change/'),
         views.CustomPasswordChangeView.as_view(),
         name='password_change',),
    path(_('password_change_done/'),
         views.CustomPasswordChangeDoneView.as_view(),
         name='password_change_done'),
    path(_('sign-up/'), views.signup, name='signup'),
]

clients/urls.py
from django.urls import path
from django.utils.translation import gettext_lazy as _

from . import views

urlpatterns = [
    path('<int:pk>/', views.ClientUpdate.as_view(),
         name='client-update'),
    path(_('<int:pk>/delete/'), views.ClientDelete.as_view(),
         name='client-delete'),
    path('', views.clients_view, name='clients'),
]

homepage/urls.py
from django.urls import path
from django.utils.translation import gettext_lazy as _
from . import views


urlpatterns = [
    path(_('search-results/'), views.search_results, name="search-results"),
    path('', views.homepage_view, name='homepage'),
]

programari/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.i18n import i18n_patterns
from django.utils.translation import gettext_lazy as _

urlpatterns = []

urlpatterns += i18n_patterns(
    path('admin/', admin.site.urls),
    path('', include(('homepage.urls', 'homepage'),
                     namespace='homepage')),
    path(_('providers/'), include(('providers.urls', 'providers'),
                                  namespace='providers')),
    path(_('services/'), include(('services.urls', 'services'),
                                 namespace='services')),
    path(_('clients/'), include(('clients.urls', 'clients'),
                                namespace='clients')),
    path(_('accounts/'), include(('accounts.urls', 'accounts'),
                                 namespace='accounts'))
)

accounts/models.py
from django.db import models

# Create your models here.

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.views import (LoginView, PasswordChangeView,
                                       PasswordChangeDoneView)
from django.contrib.auth import login, authenticate                                
from django.views.generic import UpdateView
from django.contrib.auth.models import User
from django.urls import reverse_lazy

from homepage.forms import (UserLoginForm, UserAccountForm,
                            CustomPasswordChangeForm, CustomUserCreationForm)


class CustomLoginView(LoginView):

    form_client = UserLoginForm
    extra_context = {'form_client': form_client}


class UserUpdate(UpdateView):
    model = User
    form_class = UserAccountForm
    template_name = 'accounts/user_form.html'


class CustomPasswordChangeView(PasswordChangeView):
    form_class = CustomPasswordChangeForm
    template_name = 'accounts/password_change_form.html'
    success_url = reverse_lazy('accounts:password_change_done')


class CustomPasswordChangeDoneView(PasswordChangeDoneView):
    template_name = 'accounts/password_change_done.html'


def signup(request):
    if request.method == 'POST':
        form = CustomUserCreationForm(request.POST)
        if form.is_valid():
            form.save()
            username = form.cleaned_data.get('username')
            raw_password = form.cleaned_data.get('password1')
            user = authenticate(username=username, password=raw_password)
            login(request, user)
            return redirect('homepage:homepage')
    else:
        form = CustomUserCreationForm()
    return render(request, 'accounts/sign_up.html', {'form': form})

accounts/templates/accounts/base.html
<!doctype html>
<html lang="en">

<head>
  <!-- Translations -->
  {% load i18n %}

  <title>{% trans "Appointments" %}</title>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

  <!-- Loads the path to your static files -->
  {% load static %}

  <!-- styles -->
  <!-- Bootstrap 4.0.0-beta2 CSS -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.0.0-beta.2/css/bootstrap.css" integrity="sha256-bQNoQmAU+jjEAH6JRX378IbDNnQPkLt5yWRxHn3yUYE="
    crossorigin="anonymous" />
  <!-- Bootstrap datetimepicker CSS -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datetimepicker/4.17.47/css/bootstrap-datetimepicker.css"
    integrity="sha256-b5ZKCi55IX+24Jqn638cP/q3Nb2nlx+MH/vMMqrId6k=" crossorigin="anonymous" />
  <!-- Fullcalendar -->
  <link rel='stylesheet' type='text/css' href="{% static 'fullcalendar/fullcalendar.css' %}">
  <!-- Static CSS -->
  <link rel="stylesheet" type="text/css" href="{% static 'homepage/style.css' %}">

  <!-- scripts (in the head of html, at the suggestion from fullcalendar.io)-->
  <!-- jQuery -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.js" integrity="sha256-DZAnKJ/6XZ9si04Hgrsxu/8s717jcIzLy3oi35EouyE="
    crossorigin="anonymous"></script>
  <!-- Moment.js with locales -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.19.3/moment-with-locales.js" integrity="sha256-KDB8QtKomWcCR2Ln2Ald1qDs2pvBiVqbZ+PxGzJLHj8="
    crossorigin="anonymous"></script>
  <!-- Popper.js -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.3/umd/popper.min.js" integrity="sha384-vFJXuSJphROIrBnz7yo7oB41mKfc8JzQZiCq4NCceLEaO4IHwicKwpJf9c9IpFgh"
    crossorigin="anonymous"></script>
  <!-- Bootstrap 4.0.0-beta 2 Js-->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.0.0-beta.2/js/bootstrap.js" integrity="sha256-o5aEI5KgisQLdZNoCMhg5OQcBDXoUHF5P1ubIREMaZg="
    crossorigin="anonymous"></script>
  <!-- Bootstrap datetimepicker JS -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datetimepicker/4.17.47/js/bootstrap-datetimepicker.min.js"
    integrity="sha256-5YmaxAwMjIpMrVlK84Y/+NjCpKnFYa8bWWBbUHSBGfU=" crossorigin="anonymous"></script>
  <!-- Fullcalendar -->
  <script src="{% static 'fullcalendar/lib/moment.min.js' %}"></script>
  <script src="{% static 'fullcalendar/fullcalendar.js' %}"></script>
  <!-- FontAwesome -->
  <script defer src="https://use.fontawesome.com/releases/v5.0.1/js/all.js"></script>

  <script>
    // Here get the variables needed for javascript from django
    let clientsPks = "{{ clients_pks }}";
    let clientsNames = "{{ clients_names }}";
    let clientsDates = "{{ clients_dates }}";
    let business_hours_start = "{{ business_hours_start }}";
    let business_hours_end = "{{ business_hours_end }}";
    let break_day = "{{ break_day }}"
    let break_begin = "{{ break_begin }}";
    let break_end = "{{ break_end }}";
    let breaksDayForDropdown = "{{ day_of_break }}";
    let clientServices = "{{ clientServices }}";
    let clientServicesDuration = "{{ clientServicesDuration }}"; 
    let lang = "{{ lang }}";
  </script>

  <!-- Static JS -->
  <script src="{% static 'homepage/base.js' %}"></script>

</head>

<body>

  <nav class="navbar navbar-expand-md navbar-dark bg-dark">

    <div class="navbar-brand" id="logo">Logo</div>

  </nav>

  {% block content %} {% endblock %}

</body>

</html>

accounts/templates/accounts/password_change_done.html
{% extends 'homepage/base.html' %} {% block content%}

{% load i18n %}

<div class="row">
  <div class="col-md-12 mx-2 my-2">{% trans "The password has been changed successfully" %}</div>
</div>

<button class="btn btn-info mx-2 my-2" id="home-from-password-change" value="{% url 'homepage:homepage' %}">{% trans "Home" %}</button>

{% endblock %}

accounts/templates/accounts/password_change_form.html
{% extends 'homepage/base.html' %} {% block content%}
  <!-- Translations -->
  {% load i18n %}


<div class="container">
    <h3>{% trans "Change password" %}</h3>
  
    <form class="form-horizontal" method="post">{% csrf_token %}
        {% if form.errors %}
        <p class="errornote">
            {% if form.errors.items|length == 1 %}
            {% trans "Please correct the following error" %}
            {% else %}
            {% trans "Please correct the following errors" %}
            {% endif %}
        </p>
        {% endif %}
        <p> 
            {% trans "Enter the old password, for security reasons, then the new password two times, to check that it was entered correctly." %}
        </p>
        
        <div class="form-row" id="error-user-old-password">
            <div class="form-group col-md">
                <span class="text-danger small">{{ form.old_password.errors }}</span>
            </div>
        </div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label for="{{ form.old_password.id_for_label }}">{% trans "Old password" %}</label>
                {{ form.old_password }}
                {% if form.old_password.help_text %}
                <small class="text-muted">{{ form.old_password.help_text|safe }}</small>
                {% endif %}
            </div>
        </div>

        <div class="form-row" id="error-user-new-password1">
            <div class="form-group col-md">
                <span class="text-danger small">{{ form.new_password1.errors }}</span>
            </div>
        </div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label for="{{ form.new_password1.id_for_label }}">{% trans "New password" %}</label>
                {{ form.new_password1 }}
                {% if form.new_password1.help_text %}
                    <small class="text-muted">{{ form.new_password1.help_text|safe }}</small>
                {% endif %}
            </div>
        </div>
        
        <div class="form-row" id="error-user-new-password2">
            <div class="form-group col-md">
                <span class="text-danger small">{{ form.new_password2.errors }}</span>
            </div>
        </div>
        
        <div class="form-row">
            <div class="form-group col-md-6">
                <label for="{{ form.new_password2.id_for_label }}">{% trans "Confirm new password" %}</label>
                {{ form.new_password2 }}
                {% if form.new_password2.help_text %}
                    <small class="text-muted">{{ form.new_password2.help_text|safe }}</small>
                {% endif %}
            </div>
        </div>

        <div class="submit-row">
            <input type="submit" value="change-password" class="default" />
        </div>

    </form>
</div>
{% endblock %}

accounts/templates/accounts/sign_up.html
{% extends 'accounts/base.html' %} {% block content%}
  <!-- Translations -->
  {% load i18n %}


<div class="container">
    <button class="btn btn-primary my-3" id="signup-back" value="{% url 'accounts:custom-login' %}">
        <i class="fas fa-angle-left"></i> &nbsp; {% trans "Back" %}
    </button>
    <h1>{% trans "Sign-up" %}</h1>

    <p> {% trans "Complete the following fields to sign up" %}:</p>

    <form class="form-horizontal" id="sign-up-form" method="POST" action="" role="form">
        {% csrf_token %} {{ form.non_field_errors }}

        <div class="form-row" id="error-username">
            <div class="form-group col-md-6">
                <span class="text-danger small">{{ form.username.errors }}</span>
            </div>
        </div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label for="{{ form.username.id_for_label }}">{% trans "Username" %}</label>
                {{ form.username }}
            </div>
        </div>

        <div class="form-row" id="error-email">
            <div class="form-group col-md-6">
                <span class="text-danger small">{{ form.email.errors }}</span>
            </div>
        </div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label for="{{ form.email.id_for_label }}">Email:</label>
                {{ form.email }}
            </div>
        </div>

        <div class="form-row" id="error-password1">
            <div class="form-group col-md-6">
                <span class="text-danger small">{{ form.password1.errors }}</span>
            </div>
        </div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label for="{{ form.password1.id_for_label }}">{% trans "Password" %}</label>
                {{ form.password1 }}
            </div>
        </div>

        <div class="form-row" id="error-password2">
            <div class="form-group col-md-6">
                <span class="text-danger small">{{ form.password2.errors }}</span>
            </div>
        </div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label for="{{ form.password2.id_for_label }}">{% trans "Confirm password" %}</label>
                {{ form.password2 }}
            </div>
        </div>

        <input type="hidden" name="next" value="{% url 'homepage:homepage' %}" />
        <button class="btn btn-success" type="submit">{% trans "Sign-up" %}</button>

    </form>

</div>

{% endblock %}

accounts/templates/accounts/user_form.html
{% extends 'homepage/base.html' %} {% block content %}
  <!-- Translations -->
  {% load i18n %}

<div class="row">
  <div class="col-md-2 mx-2 my-2">
    <h2>{{ user }}:</h2>
  </div>
</div>

<div class="col-12 col-md-9 col-xl-8 py-md-3 pl-md-5">
  <form class="form-horizontal" id="add-provider-form" method="POST" action="" role="form">
    {% csrf_token %} {{ form.non_field_errors }}

    <div class="form-row" id="error-client-username">
        <div class="form-group col-md-6">
            <span class="text-danger small">{{ form.username.errors }}</span>
        </div>
    </div>

    <div class="form-row">

        <div class="form-group col-md-6">
            <label for="{{ form.username.id_for_label }}">{% trans "Username" %}:</label>
            {{ form.username }} 
        </div>
    </div>

    <div class="form-row">
        <div class="form-row" id="error-client-email">
            <div class="form-group col-md-6">
                <span class="text-danger small">{{ form.email.errors }}</span>
            </div>
        </div>

        <div class="form-group col-md-6">
            <label for="{{ form.email.id_for_label }}">Email:</label>
            {{ form.email }}
        </div>
    </div>

    <button class="btn btn-success my-4" style="width:100px" type="submit">OK</button>
    <button class="btn btn-info" id="change-password" type="button" value="{% url 'accounts:password_change' user.pk %}">{% trans "Change password" %}</button>
  </form>
</div>

{% endblock %}